/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the PinterestControllerActionColumnRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &PinterestControllerActionColumnRequest{}

// PinterestControllerActionColumnRequest struct for PinterestControllerActionColumnRequest
type PinterestControllerActionColumnRequest struct {
	ReportLevel *string `json:"reportLevel,omitempty"`
}

// NewPinterestControllerActionColumnRequest instantiates a new PinterestControllerActionColumnRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewPinterestControllerActionColumnRequest() *PinterestControllerActionColumnRequest {
	this := PinterestControllerActionColumnRequest{}
	return &this
}

// NewPinterestControllerActionColumnRequestWithDefaults instantiates a new PinterestControllerActionColumnRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewPinterestControllerActionColumnRequestWithDefaults() *PinterestControllerActionColumnRequest {
	this := PinterestControllerActionColumnRequest{}
	return &this
}

// GetReportLevel returns the ReportLevel field value if set, zero value otherwise.
func (o *PinterestControllerActionColumnRequest) GetReportLevel() string {
	if o == nil || IsNil(o.ReportLevel) {
		var ret string
		return ret
	}
	return *o.ReportLevel
}

// GetReportLevelOk returns a tuple with the ReportLevel field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PinterestControllerActionColumnRequest) GetReportLevelOk() (*string, bool) {
	if o == nil || IsNil(o.ReportLevel) {
		return nil, false
	}
	return o.ReportLevel, true
}

// HasReportLevel returns a boolean if a field has been set.
func (o *PinterestControllerActionColumnRequest) HasReportLevel() bool {
	if o != nil && !IsNil(o.ReportLevel) {
		return true
	}

	return false
}

// SetReportLevel gets a reference to the given string and assigns it to the ReportLevel field.
func (o *PinterestControllerActionColumnRequest) SetReportLevel(v string) {
	o.ReportLevel = &v
}

func (o PinterestControllerActionColumnRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o PinterestControllerActionColumnRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.ReportLevel) {
		toSerialize["reportLevel"] = o.ReportLevel
	}
	return toSerialize, nil
}

type NullablePinterestControllerActionColumnRequest struct {
	value *PinterestControllerActionColumnRequest
	isSet bool
}

func (v NullablePinterestControllerActionColumnRequest) Get() *PinterestControllerActionColumnRequest {
	return v.value
}

func (v *NullablePinterestControllerActionColumnRequest) Set(val *PinterestControllerActionColumnRequest) {
	v.value = val
	v.isSet = true
}

func (v NullablePinterestControllerActionColumnRequest) IsSet() bool {
	return v.isSet
}

func (v *NullablePinterestControllerActionColumnRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullablePinterestControllerActionColumnRequest(val *PinterestControllerActionColumnRequest) *NullablePinterestControllerActionColumnRequest {
	return &NullablePinterestControllerActionColumnRequest{value: val, isSet: true}
}

func (v NullablePinterestControllerActionColumnRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullablePinterestControllerActionColumnRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
